/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "rcfile_y.y"

/*
 * rcfile_y.y -- Run control file parser for fetchmail
 *
 * For license terms, see the file COPYING in this directory.
 */

#include "config.h"
#include "fetchmail.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "i18n.h"
#include "rcfile_l.h"
  
/* parser reads these */
char *rcfile;			/* path name of rc file */
extern struct query cmd_opts;	/* where to put command-line info */

/* parser sets these */
struct query *querylist;	/* head of server list (globally visible) */

static struct query current;	/* current server record */
static int prc_errflag;
static struct hostdata *leadentry;
static flag trailer;

static void record_current(void);
static void user_reset(void);
static void reset_server(const char *name, int skip);

static void yywarn(const char *);

/* these should be of size PATH_MAX */
char currentwd[1024] = "", rcfiledir[1024] = "";

/* lexer interface */
extern int prc_lineno;

static void yywarn(const char *s)
{
    report_at_line(stderr, 0, rcfile, prc_lineno, GT_("%s at %s"), s, 
		   (yytext && yytext[0]) ? yytext : GT_("end of input"));
}

void yyerror (const char *s)
/* report a syntax error */
{
    yywarn(s);
    prc_errflag++;
}


#line 132 "rcfile_y.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_RCFILE_Y_H_INCLUDED
# define YY_YY_RCFILE_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    DEFAULTS = 258,                /* DEFAULTS  */
    POLL = 259,                    /* POLL  */
    SKIP = 260,                    /* SKIP  */
    VIA = 261,                     /* VIA  */
    AKA = 262,                     /* AKA  */
    LOCALDOMAINS = 263,            /* LOCALDOMAINS  */
    PROTOCOL = 264,                /* PROTOCOL  */
    AUTHENTICATE = 265,            /* AUTHENTICATE  */
    TIMEOUT = 266,                 /* TIMEOUT  */
    KPOP = 267,                    /* KPOP  */
    SDPS = 268,                    /* SDPS  */
    ENVELOPE = 269,                /* ENVELOPE  */
    QVIRTUAL = 270,                /* QVIRTUAL  */
    PINENTRY_TIMEOUT = 271,        /* PINENTRY_TIMEOUT  */
    PWMD_SOCKET = 272,             /* PWMD_SOCKET  */
    PWMD_SOCKET_ARGS = 273,        /* PWMD_SOCKET_ARGS  */
    PWMD_FILE = 274,               /* PWMD_FILE  */
    IDLETIMEOUT = 275,             /* IDLETIMEOUT  */
    USERNAME = 276,                /* USERNAME  */
    PASSWORD = 277,                /* PASSWORD  */
    FOLDER = 278,                  /* FOLDER  */
    SMTPHOST = 279,                /* SMTPHOST  */
    FETCHDOMAINS = 280,            /* FETCHDOMAINS  */
    MDA = 281,                     /* MDA  */
    BSMTP = 282,                   /* BSMTP  */
    LMTP = 283,                    /* LMTP  */
    PASSWORDFILE = 284,            /* PASSWORDFILE  */
    PASSWORDFD = 285,              /* PASSWORDFD  */
    PASSWORDEVAL = 286,            /* PASSWORDEVAL  */
    SMTPADDRESS = 287,             /* SMTPADDRESS  */
    SMTPNAME = 288,                /* SMTPNAME  */
    SPAMRESPONSE = 289,            /* SPAMRESPONSE  */
    PRECONNECT = 290,              /* PRECONNECT  */
    POSTCONNECT = 291,             /* POSTCONNECT  */
    LIMIT = 292,                   /* LIMIT  */
    WARNINGS = 293,                /* WARNINGS  */
    INTERFACE = 294,               /* INTERFACE  */
    MONITOR = 295,                 /* MONITOR  */
    PLUGIN = 296,                  /* PLUGIN  */
    PLUGOUT = 297,                 /* PLUGOUT  */
    IS = 298,                      /* IS  */
    HERE = 299,                    /* HERE  */
    THERE = 300,                   /* THERE  */
    TO = 301,                      /* TO  */
    MAP = 302,                     /* MAP  */
    BATCHLIMIT = 303,              /* BATCHLIMIT  */
    FETCHLIMIT = 304,              /* FETCHLIMIT  */
    FETCHSIZELIMIT = 305,          /* FETCHSIZELIMIT  */
    FASTUIDL = 306,                /* FASTUIDL  */
    EXPUNGE = 307,                 /* EXPUNGE  */
    PROPERTIES = 308,              /* PROPERTIES  */
    SET = 309,                     /* SET  */
    LOGFILE = 310,                 /* LOGFILE  */
    DAEMON = 311,                  /* DAEMON  */
    SYSLOG = 312,                  /* SYSLOG  */
    IDFILE = 313,                  /* IDFILE  */
    PIDFILE = 314,                 /* PIDFILE  */
    INVISIBLE = 315,               /* INVISIBLE  */
    POSTMASTER = 316,              /* POSTMASTER  */
    BOUNCEMAIL = 317,              /* BOUNCEMAIL  */
    SPAMBOUNCE = 318,              /* SPAMBOUNCE  */
    SOFTBOUNCE = 319,              /* SOFTBOUNCE  */
    SHOWDOTS = 320,                /* SHOWDOTS  */
    BADHEADER = 321,               /* BADHEADER  */
    ACCEPT = 322,                  /* ACCEPT  */
    REJECT_ = 323,                 /* REJECT_  */
    RETRIEVEERROR = 324,           /* RETRIEVEERROR  */
    ABORT = 325,                   /* ABORT  */
    CONTINUE = 326,                /* CONTINUE  */
    MARKSEEN = 327,                /* MARKSEEN  */
    PROTO = 328,                   /* PROTO  */
    AUTHTYPE = 329,                /* AUTHTYPE  */
    STRING = 330,                  /* STRING  */
    NUMBER = 331,                  /* NUMBER  */
    NO = 332,                      /* NO  */
    KEEP = 333,                    /* KEEP  */
    FLUSH = 334,                   /* FLUSH  */
    LIMITFLUSH = 335,              /* LIMITFLUSH  */
    FETCHALL = 336,                /* FETCHALL  */
    REWRITE = 337,                 /* REWRITE  */
    FORCECR = 338,                 /* FORCECR  */
    STRIPCR = 339,                 /* STRIPCR  */
    PASS8BITS = 340,               /* PASS8BITS  */
    DROPSTATUS = 341,              /* DROPSTATUS  */
    DROPDELIVERED = 342,           /* DROPDELIVERED  */
    FORCEIDLE = 343,               /* FORCEIDLE  */
    DNS = 344,                     /* DNS  */
    SERVICE = 345,                 /* SERVICE  */
    PORT = 346,                    /* PORT  */
    UIDL = 347,                    /* UIDL  */
    INTERVAL = 348,                /* INTERVAL  */
    MIMEDECODE = 349,              /* MIMEDECODE  */
    IDLE = 350,                    /* IDLE  */
    CHECKALIAS = 351,              /* CHECKALIAS  */
    SSL_ = 352,                    /* SSL_  */
    SSLKEY = 353,                  /* SSLKEY  */
    SSLCERT = 354,                 /* SSLCERT  */
    SSLMODE = 355,                 /* SSLMODE  */
    SSLPROTOVER = 356,             /* SSLPROTOVER  */
    SSLCERTCK = 357,               /* SSLCERTCK  */
    SSLCERTFILE = 358,             /* SSLCERTFILE  */
    SSLCERTPATH = 359,             /* SSLCERTPATH  */
    SSLCOMMONNAME = 360,           /* SSLCOMMONNAME  */
    SSLFINGERPRINT = 361,          /* SSLFINGERPRINT  */
    PRINCIPAL = 362,               /* PRINCIPAL  */
    ESMTPNAME = 363,               /* ESMTPNAME  */
    ESMTPPASSWORD = 364,           /* ESMTPPASSWORD  */
    TRACEPOLLS = 365               /* TRACEPOLLS  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define DEFAULTS 258
#define POLL 259
#define SKIP 260
#define VIA 261
#define AKA 262
#define LOCALDOMAINS 263
#define PROTOCOL 264
#define AUTHENTICATE 265
#define TIMEOUT 266
#define KPOP 267
#define SDPS 268
#define ENVELOPE 269
#define QVIRTUAL 270
#define PINENTRY_TIMEOUT 271
#define PWMD_SOCKET 272
#define PWMD_SOCKET_ARGS 273
#define PWMD_FILE 274
#define IDLETIMEOUT 275
#define USERNAME 276
#define PASSWORD 277
#define FOLDER 278
#define SMTPHOST 279
#define FETCHDOMAINS 280
#define MDA 281
#define BSMTP 282
#define LMTP 283
#define PASSWORDFILE 284
#define PASSWORDFD 285
#define PASSWORDEVAL 286
#define SMTPADDRESS 287
#define SMTPNAME 288
#define SPAMRESPONSE 289
#define PRECONNECT 290
#define POSTCONNECT 291
#define LIMIT 292
#define WARNINGS 293
#define INTERFACE 294
#define MONITOR 295
#define PLUGIN 296
#define PLUGOUT 297
#define IS 298
#define HERE 299
#define THERE 300
#define TO 301
#define MAP 302
#define BATCHLIMIT 303
#define FETCHLIMIT 304
#define FETCHSIZELIMIT 305
#define FASTUIDL 306
#define EXPUNGE 307
#define PROPERTIES 308
#define SET 309
#define LOGFILE 310
#define DAEMON 311
#define SYSLOG 312
#define IDFILE 313
#define PIDFILE 314
#define INVISIBLE 315
#define POSTMASTER 316
#define BOUNCEMAIL 317
#define SPAMBOUNCE 318
#define SOFTBOUNCE 319
#define SHOWDOTS 320
#define BADHEADER 321
#define ACCEPT 322
#define REJECT_ 323
#define RETRIEVEERROR 324
#define ABORT 325
#define CONTINUE 326
#define MARKSEEN 327
#define PROTO 328
#define AUTHTYPE 329
#define STRING 330
#define NUMBER 331
#define NO 332
#define KEEP 333
#define FLUSH 334
#define LIMITFLUSH 335
#define FETCHALL 336
#define REWRITE 337
#define FORCECR 338
#define STRIPCR 339
#define PASS8BITS 340
#define DROPSTATUS 341
#define DROPDELIVERED 342
#define FORCEIDLE 343
#define DNS 344
#define SERVICE 345
#define PORT 346
#define UIDL 347
#define INTERVAL 348
#define MIMEDECODE 349
#define IDLE 350
#define CHECKALIAS 351
#define SSL_ 352
#define SSLKEY 353
#define SSLCERT 354
#define SSLMODE 355
#define SSLPROTOVER 356
#define SSLCERTCK 357
#define SSLCERTFILE 358
#define SSLCERTPATH 359
#define SSLCOMMONNAME 360
#define SSLFINGERPRINT 361
#define PRINCIPAL 362
#define ESMTPNAME 363
#define ESMTPPASSWORD 364
#define TRACEPOLLS 365

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 62 "rcfile_y.y"

  int proto;
  int number;
  char *sval;

#line 411 "rcfile_y.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_RCFILE_Y_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DEFAULTS = 3,                   /* DEFAULTS  */
  YYSYMBOL_POLL = 4,                       /* POLL  */
  YYSYMBOL_SKIP = 5,                       /* SKIP  */
  YYSYMBOL_VIA = 6,                        /* VIA  */
  YYSYMBOL_AKA = 7,                        /* AKA  */
  YYSYMBOL_LOCALDOMAINS = 8,               /* LOCALDOMAINS  */
  YYSYMBOL_PROTOCOL = 9,                   /* PROTOCOL  */
  YYSYMBOL_AUTHENTICATE = 10,              /* AUTHENTICATE  */
  YYSYMBOL_TIMEOUT = 11,                   /* TIMEOUT  */
  YYSYMBOL_KPOP = 12,                      /* KPOP  */
  YYSYMBOL_SDPS = 13,                      /* SDPS  */
  YYSYMBOL_ENVELOPE = 14,                  /* ENVELOPE  */
  YYSYMBOL_QVIRTUAL = 15,                  /* QVIRTUAL  */
  YYSYMBOL_PINENTRY_TIMEOUT = 16,          /* PINENTRY_TIMEOUT  */
  YYSYMBOL_PWMD_SOCKET = 17,               /* PWMD_SOCKET  */
  YYSYMBOL_PWMD_SOCKET_ARGS = 18,          /* PWMD_SOCKET_ARGS  */
  YYSYMBOL_PWMD_FILE = 19,                 /* PWMD_FILE  */
  YYSYMBOL_IDLETIMEOUT = 20,               /* IDLETIMEOUT  */
  YYSYMBOL_USERNAME = 21,                  /* USERNAME  */
  YYSYMBOL_PASSWORD = 22,                  /* PASSWORD  */
  YYSYMBOL_FOLDER = 23,                    /* FOLDER  */
  YYSYMBOL_SMTPHOST = 24,                  /* SMTPHOST  */
  YYSYMBOL_FETCHDOMAINS = 25,              /* FETCHDOMAINS  */
  YYSYMBOL_MDA = 26,                       /* MDA  */
  YYSYMBOL_BSMTP = 27,                     /* BSMTP  */
  YYSYMBOL_LMTP = 28,                      /* LMTP  */
  YYSYMBOL_PASSWORDFILE = 29,              /* PASSWORDFILE  */
  YYSYMBOL_PASSWORDFD = 30,                /* PASSWORDFD  */
  YYSYMBOL_PASSWORDEVAL = 31,              /* PASSWORDEVAL  */
  YYSYMBOL_SMTPADDRESS = 32,               /* SMTPADDRESS  */
  YYSYMBOL_SMTPNAME = 33,                  /* SMTPNAME  */
  YYSYMBOL_SPAMRESPONSE = 34,              /* SPAMRESPONSE  */
  YYSYMBOL_PRECONNECT = 35,                /* PRECONNECT  */
  YYSYMBOL_POSTCONNECT = 36,               /* POSTCONNECT  */
  YYSYMBOL_LIMIT = 37,                     /* LIMIT  */
  YYSYMBOL_WARNINGS = 38,                  /* WARNINGS  */
  YYSYMBOL_INTERFACE = 39,                 /* INTERFACE  */
  YYSYMBOL_MONITOR = 40,                   /* MONITOR  */
  YYSYMBOL_PLUGIN = 41,                    /* PLUGIN  */
  YYSYMBOL_PLUGOUT = 42,                   /* PLUGOUT  */
  YYSYMBOL_IS = 43,                        /* IS  */
  YYSYMBOL_HERE = 44,                      /* HERE  */
  YYSYMBOL_THERE = 45,                     /* THERE  */
  YYSYMBOL_TO = 46,                        /* TO  */
  YYSYMBOL_MAP = 47,                       /* MAP  */
  YYSYMBOL_BATCHLIMIT = 48,                /* BATCHLIMIT  */
  YYSYMBOL_FETCHLIMIT = 49,                /* FETCHLIMIT  */
  YYSYMBOL_FETCHSIZELIMIT = 50,            /* FETCHSIZELIMIT  */
  YYSYMBOL_FASTUIDL = 51,                  /* FASTUIDL  */
  YYSYMBOL_EXPUNGE = 52,                   /* EXPUNGE  */
  YYSYMBOL_PROPERTIES = 53,                /* PROPERTIES  */
  YYSYMBOL_SET = 54,                       /* SET  */
  YYSYMBOL_LOGFILE = 55,                   /* LOGFILE  */
  YYSYMBOL_DAEMON = 56,                    /* DAEMON  */
  YYSYMBOL_SYSLOG = 57,                    /* SYSLOG  */
  YYSYMBOL_IDFILE = 58,                    /* IDFILE  */
  YYSYMBOL_PIDFILE = 59,                   /* PIDFILE  */
  YYSYMBOL_INVISIBLE = 60,                 /* INVISIBLE  */
  YYSYMBOL_POSTMASTER = 61,                /* POSTMASTER  */
  YYSYMBOL_BOUNCEMAIL = 62,                /* BOUNCEMAIL  */
  YYSYMBOL_SPAMBOUNCE = 63,                /* SPAMBOUNCE  */
  YYSYMBOL_SOFTBOUNCE = 64,                /* SOFTBOUNCE  */
  YYSYMBOL_SHOWDOTS = 65,                  /* SHOWDOTS  */
  YYSYMBOL_BADHEADER = 66,                 /* BADHEADER  */
  YYSYMBOL_ACCEPT = 67,                    /* ACCEPT  */
  YYSYMBOL_REJECT_ = 68,                   /* REJECT_  */
  YYSYMBOL_RETRIEVEERROR = 69,             /* RETRIEVEERROR  */
  YYSYMBOL_ABORT = 70,                     /* ABORT  */
  YYSYMBOL_CONTINUE = 71,                  /* CONTINUE  */
  YYSYMBOL_MARKSEEN = 72,                  /* MARKSEEN  */
  YYSYMBOL_PROTO = 73,                     /* PROTO  */
  YYSYMBOL_AUTHTYPE = 74,                  /* AUTHTYPE  */
  YYSYMBOL_STRING = 75,                    /* STRING  */
  YYSYMBOL_NUMBER = 76,                    /* NUMBER  */
  YYSYMBOL_NO = 77,                        /* NO  */
  YYSYMBOL_KEEP = 78,                      /* KEEP  */
  YYSYMBOL_FLUSH = 79,                     /* FLUSH  */
  YYSYMBOL_LIMITFLUSH = 80,                /* LIMITFLUSH  */
  YYSYMBOL_FETCHALL = 81,                  /* FETCHALL  */
  YYSYMBOL_REWRITE = 82,                   /* REWRITE  */
  YYSYMBOL_FORCECR = 83,                   /* FORCECR  */
  YYSYMBOL_STRIPCR = 84,                   /* STRIPCR  */
  YYSYMBOL_PASS8BITS = 85,                 /* PASS8BITS  */
  YYSYMBOL_DROPSTATUS = 86,                /* DROPSTATUS  */
  YYSYMBOL_DROPDELIVERED = 87,             /* DROPDELIVERED  */
  YYSYMBOL_FORCEIDLE = 88,                 /* FORCEIDLE  */
  YYSYMBOL_DNS = 89,                       /* DNS  */
  YYSYMBOL_SERVICE = 90,                   /* SERVICE  */
  YYSYMBOL_PORT = 91,                      /* PORT  */
  YYSYMBOL_UIDL = 92,                      /* UIDL  */
  YYSYMBOL_INTERVAL = 93,                  /* INTERVAL  */
  YYSYMBOL_MIMEDECODE = 94,                /* MIMEDECODE  */
  YYSYMBOL_IDLE = 95,                      /* IDLE  */
  YYSYMBOL_CHECKALIAS = 96,                /* CHECKALIAS  */
  YYSYMBOL_SSL_ = 97,                      /* SSL_  */
  YYSYMBOL_SSLKEY = 98,                    /* SSLKEY  */
  YYSYMBOL_SSLCERT = 99,                   /* SSLCERT  */
  YYSYMBOL_SSLMODE = 100,                  /* SSLMODE  */
  YYSYMBOL_SSLPROTOVER = 101,              /* SSLPROTOVER  */
  YYSYMBOL_SSLCERTCK = 102,                /* SSLCERTCK  */
  YYSYMBOL_SSLCERTFILE = 103,              /* SSLCERTFILE  */
  YYSYMBOL_SSLCERTPATH = 104,              /* SSLCERTPATH  */
  YYSYMBOL_SSLCOMMONNAME = 105,            /* SSLCOMMONNAME  */
  YYSYMBOL_SSLFINGERPRINT = 106,           /* SSLFINGERPRINT  */
  YYSYMBOL_PRINCIPAL = 107,                /* PRINCIPAL  */
  YYSYMBOL_ESMTPNAME = 108,                /* ESMTPNAME  */
  YYSYMBOL_ESMTPPASSWORD = 109,            /* ESMTPPASSWORD  */
  YYSYMBOL_TRACEPOLLS = 110,               /* TRACEPOLLS  */
  YYSYMBOL_YYACCEPT = 111,                 /* $accept  */
  YYSYMBOL_rcfile = 112,                   /* rcfile  */
  YYSYMBOL_statement_list = 113,           /* statement_list  */
  YYSYMBOL_optmap = 114,                   /* optmap  */
  YYSYMBOL_statement = 115,                /* statement  */
  YYSYMBOL_define_server = 116,            /* define_server  */
  YYSYMBOL_serverspecs = 117,              /* serverspecs  */
  YYSYMBOL_alias_list = 118,               /* alias_list  */
  YYSYMBOL_domain_list = 119,              /* domain_list  */
  YYSYMBOL_serv_option = 120,              /* serv_option  */
  YYSYMBOL_userspecs = 121,                /* userspecs  */
  YYSYMBOL_explicits = 122,                /* explicits  */
  YYSYMBOL_explicitdef = 123,              /* explicitdef  */
  YYSYMBOL_userdef = 124,                  /* userdef  */
  YYSYMBOL_user0opts = 125,                /* user0opts  */
  YYSYMBOL_user1opts = 126,                /* user1opts  */
  YYSYMBOL_mapping_list = 127,             /* mapping_list  */
  YYSYMBOL_mapping = 128,                  /* mapping  */
  YYSYMBOL_folder_list = 129,              /* folder_list  */
  YYSYMBOL_smtp_list = 130,                /* smtp_list  */
  YYSYMBOL_fetch_list = 131,               /* fetch_list  */
  YYSYMBOL_num_list = 132,                 /* num_list  */
  YYSYMBOL_user_option = 133               /* user_option  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  25
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   354

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  111
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  23
/* YYNRULES -- Number of rules.  */
#define YYNRULES  168
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  250

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   365


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    98,    98,    99,   102,   103,   106,   106,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   141,   142,   145,
     149,   150,   151,   154,   155,   158,   159,   162,   163,   166,
     167,   168,   169,   170,   180,   181,   182,   183,   191,   192,
     193,   194,   195,   198,   204,   210,   212,   214,   216,   218,
     223,   229,   230,   238,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   260,   261,   264,   265,
     268,   271,   272,   273,   276,   277,   280,   281,   284,   285,
     288,   294,   297,   298,   301,   302,   305,   306,   309,   315,
     323,   324,   325,   326,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   359,   368,   369,   370,   374,   375,   376,
     377,   378,   379,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   395,   396,   398,   399,
     400,   401,   402,   403,   404,   406,   408,   415,   422
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DEFAULTS", "POLL",
  "SKIP", "VIA", "AKA", "LOCALDOMAINS", "PROTOCOL", "AUTHENTICATE",
  "TIMEOUT", "KPOP", "SDPS", "ENVELOPE", "QVIRTUAL", "PINENTRY_TIMEOUT",
  "PWMD_SOCKET", "PWMD_SOCKET_ARGS", "PWMD_FILE", "IDLETIMEOUT",
  "USERNAME", "PASSWORD", "FOLDER", "SMTPHOST", "FETCHDOMAINS", "MDA",
  "BSMTP", "LMTP", "PASSWORDFILE", "PASSWORDFD", "PASSWORDEVAL",
  "SMTPADDRESS", "SMTPNAME", "SPAMRESPONSE", "PRECONNECT", "POSTCONNECT",
  "LIMIT", "WARNINGS", "INTERFACE", "MONITOR", "PLUGIN", "PLUGOUT", "IS",
  "HERE", "THERE", "TO", "MAP", "BATCHLIMIT", "FETCHLIMIT",
  "FETCHSIZELIMIT", "FASTUIDL", "EXPUNGE", "PROPERTIES", "SET", "LOGFILE",
  "DAEMON", "SYSLOG", "IDFILE", "PIDFILE", "INVISIBLE", "POSTMASTER",
  "BOUNCEMAIL", "SPAMBOUNCE", "SOFTBOUNCE", "SHOWDOTS", "BADHEADER",
  "ACCEPT", "REJECT_", "RETRIEVEERROR", "ABORT", "CONTINUE", "MARKSEEN",
  "PROTO", "AUTHTYPE", "STRING", "NUMBER", "NO", "KEEP", "FLUSH",
  "LIMITFLUSH", "FETCHALL", "REWRITE", "FORCECR", "STRIPCR", "PASS8BITS",
  "DROPSTATUS", "DROPDELIVERED", "FORCEIDLE", "DNS", "SERVICE", "PORT",
  "UIDL", "INTERVAL", "MIMEDECODE", "IDLE", "CHECKALIAS", "SSL_", "SSLKEY",
  "SSLCERT", "SSLMODE", "SSLPROTOVER", "SSLCERTCK", "SSLCERTFILE",
  "SSLCERTPATH", "SSLCOMMONNAME", "SSLFINGERPRINT", "PRINCIPAL",
  "ESMTPNAME", "ESMTPPASSWORD", "TRACEPOLLS", "$accept", "rcfile",
  "statement_list", "optmap", "statement", "define_server", "serverspecs",
  "alias_list", "domain_list", "serv_option", "userspecs", "explicits",
  "explicitdef", "userdef", "user0opts", "user1opts", "mapping_list",
  "mapping", "folder_list", "smtp_list", "fetch_list", "num_list",
  "user_option", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365
};
#endif

#define YYPACT_NINF (-126)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-91)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      64,  -126,   -68,   -64,    97,    52,    64,  -126,  -126,  -126,
    -126,    11,    11,    11,    11,  -126,    11,    11,  -126,    11,
    -126,  -126,  -126,  -126,    66,  -126,  -126,    -5,  -126,   -10,
      44,    50,    -6,    89,    91,    96,  -126,  -126,  -126,  -126,
    -126,  -126,    98,   100,   102,    41,    53,    63,    61,   104,
     105,   106,   107,   108,   110,   111,   112,   113,   114,   120,
     121,  -126,   123,   124,   126,   127,   128,   129,   131,   132,
     148,   149,   152,   157,   158,   159,   160,   162,   163,   167,
     186,   187,   188,   190,    77,   -21,   134,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,    71,
     191,  -126,   192,  -126,  -126,  -126,  -126,   195,   202,   203,
     204,  -126,   205,   206,   207,   208,   209,   210,   211,  -126,
    -126,   101,   151,  -126,  -126,   223,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,   212,  -126,   213,  -126,
    -126,  -126,  -126,  -126,  -126,   214,  -126,  -126,  -126,  -126,
    -126,    88,   -36,  -126,  -126,  -126,   215,  -126,   216,  -126,
     217,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,   218,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,    18,    -4,
     136,    90,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,    28,  -126,
    -126,   223,   252,  -126,  -126,  -126,  -126,  -126,   220,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    32,     0,     0,     0,     0,     3,     4,    33,    30,
      31,     7,     7,     7,     7,    20,     7,     7,    22,     7,
      13,    15,    17,    24,     0,     1,     5,    27,     6,     0,
       0,     0,     0,     0,     0,     0,    21,    23,    14,    16,
      18,    25,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   132,    66,     0,
       0,    48,     0,   130,   131,    50,   133,     0,     0,     0,
       0,   138,     0,     0,     0,     0,     0,     0,     0,    69,
      34,    28,    77,    78,    84,    76,    86,    26,    19,     8,
      11,     9,    10,    12,    40,    35,    39,    37,    41,    43,
      47,    42,    56,    57,    60,     0,    61,   166,   167,   168,
      58,    81,     0,    88,   105,    92,   109,    94,   110,    96,
     111,   115,   116,   106,   107,   108,   112,   113,    98,   114,
     118,   119,   158,   159,    62,    63,    64,    65,    90,   103,
      90,   101,   163,   160,   161,   162,   164,   165,    71,    72,
      73,    74,    75,    68,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   155,    67,    49,   153,   154,    51,
     156,   157,    70,    52,    53,    54,    55,   134,   135,   136,
     137,   139,   140,   141,   142,    44,    45,    46,     0,    29,
      79,    80,     0,    87,    36,    38,    59,    83,     0,    82,
      89,    93,    95,    97,    99,   104,   102,   100,    85,    91
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -126,  -126,  -126,    43,   170,  -126,  -126,  -126,  -126,    78,
    -126,  -126,    82,  -126,  -126,  -126,    92,   -30,  -126,  -126,
    -126,  -126,  -125
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,    29,     7,     8,    27,   136,   138,   120,
     121,   122,   123,   124,   231,   125,   152,   153,   156,   158,
     160,   169,   126
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     233,    42,    43,    44,    45,    46,    47,     9,   239,    48,
      49,    10,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,   180,
     246,    77,   193,    78,    79,    80,    81,    82,    83,   190,
     191,   192,    25,   139,   140,    30,    31,    32,    28,    33,
      34,    84,    35,   245,    85,   238,   127,     1,     2,     3,
     130,   180,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   248,    42,    43,    44,
      45,    46,    47,    11,   141,    48,    49,   205,     4,   128,
     206,    53,   240,    36,   209,   129,    37,   142,    38,    39,
      40,    41,   -90,   237,   247,   238,   144,   145,   212,   143,
      72,    73,    74,    75,   188,   189,   213,   214,   193,   240,
      12,   240,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,   -90,   131,   180,   132,    84,   179,   181,
      85,   133,    54,   134,    24,   135,    26,   137,   228,   146,
     147,   148,   149,   238,   150,   151,   154,   155,   157,   159,
      98,    99,   100,   101,   102,   161,   162,   105,   163,   229,
     164,   165,   166,   167,   230,   168,   170,   171,   116,   117,
     118,   119,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   172,   173,   206,   174,   207,   208,
     209,   210,   175,   176,   177,   178,   211,   180,     0,   182,
      50,    51,    52,   183,   212,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,   184,   185,   186,   187,    76,   215,   216,    77,
     217,    78,    79,    80,    81,    82,    83,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   234,   235,   236,
     241,   242,   243,     0,   244,   249,     0,     0,     0,     0,
     232,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,     0,     0,     0,     0,     0,   103,   104,     0,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,     0,     0,     0,     0,     0,   207,   208,     0,   210,
       0,     0,     0,     0,   211
};

static const yytype_int16 yycheck[] =
{
     125,     6,     7,     8,     9,    10,    11,    75,    44,    14,
      15,    75,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    75,
      44,    46,    14,    48,    49,    50,    51,    52,    53,    70,
      71,    72,     0,    12,    13,    12,    13,    14,    47,    16,
      17,    66,    19,    45,    69,    47,    76,     3,     4,     5,
      76,    75,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   231,     6,     7,     8,
       9,    10,    11,    16,    73,    14,    15,    89,    54,    75,
      92,    20,   152,    57,    96,    75,    60,    74,    62,    63,
      64,    65,    44,    45,    44,    47,    75,    76,   110,    76,
      39,    40,    41,    42,    67,    68,    75,    76,    14,   179,
      53,   181,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    75,    75,    75,    75,    66,    76,    77,
      69,    75,    21,    75,    77,    75,     6,    75,    77,    75,
      75,    75,    75,    47,    76,    75,    75,    75,    75,    75,
      89,    90,    91,    92,    93,    75,    75,    96,    75,   121,
      76,    75,    75,    75,   122,    76,    75,    75,   107,   108,
     109,   110,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    76,    76,    92,    75,    94,    95,
      96,    97,    75,    75,    75,    75,   102,    75,    -1,    76,
      17,    18,    19,    76,   110,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    76,    76,    76,    75,    43,    76,    76,    46,
      75,    48,    49,    50,    51,    52,    53,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    -1,    76,    75,    -1,    -1,    -1,    -1,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,    97,
      -1,    -1,    -1,    -1,   102
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,    54,   112,   113,   115,   116,    75,
      75,    16,    53,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    77,     0,   115,   117,    47,   114,
     114,   114,   114,   114,   114,   114,    57,    60,    62,    63,
      64,    65,     6,     7,     8,     9,    10,    11,    14,    15,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    46,    48,    49,
      50,    51,    52,    53,    66,    69,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     120,   121,   122,   123,   124,   126,   133,    76,    75,    75,
      76,    75,    75,    75,    75,    75,   118,    75,   119,    12,
      13,    73,    74,    76,    75,    76,    75,    75,    75,    75,
      76,    75,   127,   128,    75,    75,   129,    75,   130,    75,
     131,    75,    75,    75,    76,    75,    75,    75,    76,   132,
      75,    75,    76,    76,    75,    75,    75,    75,    75,   127,
      75,   127,    76,    76,    76,    76,    76,    75,    67,    68,
      70,    71,    72,    14,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    92,    94,    95,    96,
      97,   102,   110,    75,    76,    76,    76,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    77,   120,
     123,   125,    77,   133,    75,    75,    75,    45,    47,    44,
     128,    75,    75,    75,    76,    45,    44,    44,   133,    75
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   111,   112,   112,   113,   113,   114,   114,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     116,   116,   116,   117,   117,   118,   118,   119,   119,   120,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   120,   120,   120,   120,   121,   121,   122,   122,
     123,   124,   124,   124,   125,   125,   126,   126,   127,   127,
     128,   128,   129,   129,   130,   130,   131,   131,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     0,     4,     4,
       4,     4,     4,     2,     3,     2,     3,     2,     3,     4,
       2,     3,     2,     3,     2,     3,     4,     2,     3,     4,
       2,     2,     1,     0,     2,     1,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     2,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     1,
       2,     2,     2,     2,     2,     2,     1,     1,     1,     2,
       2,     2,     3,     3,     0,     2,     1,     2,     1,     2,
       1,     3,     1,     2,     1,     2,     1,     2,     1,     2,
       3,     2,     3,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_STRING: /* STRING  */
#line 94 "rcfile_y.y"
            { free (((*yyvaluep).sval)); }
#line 1483 "rcfile_y.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 8: /* statement: SET LOGFILE optmap STRING  */
#line 109 "rcfile_y.y"
                                                {run.logfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 1751 "rcfile_y.c"
    break;

  case 9: /* statement: SET IDFILE optmap STRING  */
#line 110 "rcfile_y.y"
                                                {run.idfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 1757 "rcfile_y.c"
    break;

  case 10: /* statement: SET PIDFILE optmap STRING  */
#line 111 "rcfile_y.y"
                                                {run.pidfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 1763 "rcfile_y.c"
    break;

  case 11: /* statement: SET DAEMON optmap NUMBER  */
#line 112 "rcfile_y.y"
                                                {run.poll_interval = (yyvsp[0].number);}
#line 1769 "rcfile_y.c"
    break;

  case 12: /* statement: SET POSTMASTER optmap STRING  */
#line 113 "rcfile_y.y"
                                                {run.postmaster = (yyvsp[0].sval);}
#line 1775 "rcfile_y.c"
    break;

  case 13: /* statement: SET BOUNCEMAIL  */
#line 114 "rcfile_y.y"
                                                {run.bouncemail = TRUE;}
#line 1781 "rcfile_y.c"
    break;

  case 14: /* statement: SET NO BOUNCEMAIL  */
#line 115 "rcfile_y.y"
                                                {run.bouncemail = FALSE;}
#line 1787 "rcfile_y.c"
    break;

  case 15: /* statement: SET SPAMBOUNCE  */
#line 116 "rcfile_y.y"
                                                {run.spambounce = TRUE;}
#line 1793 "rcfile_y.c"
    break;

  case 16: /* statement: SET NO SPAMBOUNCE  */
#line 117 "rcfile_y.y"
                                                {run.spambounce = FALSE;}
#line 1799 "rcfile_y.c"
    break;

  case 17: /* statement: SET SOFTBOUNCE  */
#line 118 "rcfile_y.y"
                                                {run.softbounce = TRUE;}
#line 1805 "rcfile_y.c"
    break;

  case 18: /* statement: SET NO SOFTBOUNCE  */
#line 119 "rcfile_y.y"
                                                {run.softbounce = FALSE;}
#line 1811 "rcfile_y.c"
    break;

  case 19: /* statement: SET PROPERTIES optmap STRING  */
#line 120 "rcfile_y.y"
                                                {run.properties = (yyvsp[0].sval);}
#line 1817 "rcfile_y.c"
    break;

  case 20: /* statement: SET SYSLOG  */
#line 121 "rcfile_y.y"
                                                {run.use_syslog = TRUE;}
#line 1823 "rcfile_y.c"
    break;

  case 21: /* statement: SET NO SYSLOG  */
#line 122 "rcfile_y.y"
                                                {run.use_syslog = FALSE;}
#line 1829 "rcfile_y.c"
    break;

  case 22: /* statement: SET INVISIBLE  */
#line 123 "rcfile_y.y"
                                                {run.invisible = TRUE;}
#line 1835 "rcfile_y.c"
    break;

  case 23: /* statement: SET NO INVISIBLE  */
#line 124 "rcfile_y.y"
                                                {run.invisible = FALSE;}
#line 1841 "rcfile_y.c"
    break;

  case 24: /* statement: SET SHOWDOTS  */
#line 125 "rcfile_y.y"
                                                {run.showdots = FLAG_TRUE;}
#line 1847 "rcfile_y.c"
    break;

  case 25: /* statement: SET NO SHOWDOTS  */
#line 126 "rcfile_y.y"
                                                {run.showdots = FLAG_FALSE;}
#line 1853 "rcfile_y.c"
    break;

  case 26: /* statement: SET PINENTRY_TIMEOUT optmap NUMBER  */
#line 127 "rcfile_y.y"
                                                     {
#ifdef HAVE_LIBPWMD
		    run.pinentry_timeout = (yyvsp[0].number);
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
		    }
#line 1865 "rcfile_y.c"
    break;

  case 27: /* statement: define_server serverspecs  */
#line 141 "rcfile_y.y"
                                                        {record_current();}
#line 1871 "rcfile_y.c"
    break;

  case 29: /* statement: define_server serverspecs userspecs serv_option  */
#line 146 "rcfile_y.y"
                        {yyerror(GT_("server option after user options"));}
#line 1877 "rcfile_y.c"
    break;

  case 30: /* define_server: POLL STRING  */
#line 149 "rcfile_y.y"
                                        {reset_server((yyvsp[0].sval), FALSE); free((yyvsp[0].sval));}
#line 1883 "rcfile_y.c"
    break;

  case 31: /* define_server: SKIP STRING  */
#line 150 "rcfile_y.y"
                                        {reset_server((yyvsp[0].sval), TRUE);  free((yyvsp[0].sval));}
#line 1889 "rcfile_y.c"
    break;

  case 32: /* define_server: DEFAULTS  */
#line 151 "rcfile_y.y"
                                        {reset_server("defaults", FALSE);}
#line 1895 "rcfile_y.c"
    break;

  case 35: /* alias_list: STRING  */
#line 158 "rcfile_y.y"
                                        {save_str(&current.server.akalist,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1901 "rcfile_y.c"
    break;

  case 36: /* alias_list: alias_list STRING  */
#line 159 "rcfile_y.y"
                                        {save_str(&current.server.akalist,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1907 "rcfile_y.c"
    break;

  case 37: /* domain_list: STRING  */
#line 162 "rcfile_y.y"
                                        {save_str(&current.server.localdomains,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1913 "rcfile_y.c"
    break;

  case 38: /* domain_list: domain_list STRING  */
#line 163 "rcfile_y.y"
                                        {save_str(&current.server.localdomains,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 1919 "rcfile_y.c"
    break;

  case 40: /* serv_option: VIA STRING  */
#line 167 "rcfile_y.y"
                                        {current.server.via = (yyvsp[0].sval);}
#line 1925 "rcfile_y.c"
    break;

  case 42: /* serv_option: PROTOCOL PROTO  */
#line 169 "rcfile_y.y"
                                        {current.server.protocol = (yyvsp[0].proto);}
#line 1931 "rcfile_y.c"
    break;

  case 43: /* serv_option: PROTOCOL KPOP  */
#line 170 "rcfile_y.y"
                                        {
					    current.server.protocol = P_POP3;
#ifdef KERBEROS_V5
					    if (current.server.authenticate == A_PASSWORD)
						current.server.authenticate = A_KERBEROS_V5;
					    current.server.service = KPOP_PORT;
#else
					    yyerror(GT_("Kerberos not enabled."));
#endif
					}
#line 1946 "rcfile_y.c"
    break;

  case 44: /* serv_option: PRINCIPAL STRING  */
#line 180 "rcfile_y.y"
                                        {current.server.principal = (yyvsp[0].sval);}
#line 1952 "rcfile_y.c"
    break;

  case 45: /* serv_option: ESMTPNAME STRING  */
#line 181 "rcfile_y.y"
                                        {current.server.esmtp_name = (yyvsp[0].sval);}
#line 1958 "rcfile_y.c"
    break;

  case 46: /* serv_option: ESMTPPASSWORD STRING  */
#line 182 "rcfile_y.y"
                                        {current.server.esmtp_password = (yyvsp[0].sval);}
#line 1964 "rcfile_y.c"
    break;

  case 47: /* serv_option: PROTOCOL SDPS  */
#line 183 "rcfile_y.y"
                                        {
#ifdef SDPS_ENABLE
					    current.server.protocol = P_POP3;
					    current.server.sdps = TRUE;
#else
					    yyerror(GT_("SDPS not enabled."));
#endif /* SDPS_ENABLE */
					}
#line 1977 "rcfile_y.c"
    break;

  case 48: /* serv_option: UIDL  */
#line 191 "rcfile_y.y"
                                        {/* EMPTY - removed in 7.0.0 */}
#line 1983 "rcfile_y.c"
    break;

  case 49: /* serv_option: NO UIDL  */
#line 192 "rcfile_y.y"
                                        {/* EMPTY - removed in 7.0.0 */}
#line 1989 "rcfile_y.c"
    break;

  case 50: /* serv_option: CHECKALIAS  */
#line 193 "rcfile_y.y"
                                        {current.server.checkalias = FLAG_TRUE;}
#line 1995 "rcfile_y.c"
    break;

  case 51: /* serv_option: NO CHECKALIAS  */
#line 194 "rcfile_y.y"
                                        {current.server.checkalias  = FLAG_FALSE;}
#line 2001 "rcfile_y.c"
    break;

  case 52: /* serv_option: SERVICE STRING  */
#line 195 "rcfile_y.y"
                                        {
					current.server.service = (yyvsp[0].sval);
					}
#line 2009 "rcfile_y.c"
    break;

  case 53: /* serv_option: SERVICE NUMBER  */
#line 198 "rcfile_y.y"
                                        {
					int port = (yyvsp[0].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
#line 2020 "rcfile_y.c"
    break;

  case 54: /* serv_option: PORT NUMBER  */
#line 204 "rcfile_y.y"
                                        {
					int port = (yyvsp[0].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
#line 2031 "rcfile_y.c"
    break;

  case 55: /* serv_option: INTERVAL NUMBER  */
#line 211 "rcfile_y.y"
                        {current.server.interval = (yyvsp[0].number);}
#line 2037 "rcfile_y.c"
    break;

  case 56: /* serv_option: AUTHENTICATE AUTHTYPE  */
#line 213 "rcfile_y.y"
                        {current.server.authenticate = (yyvsp[0].proto);}
#line 2043 "rcfile_y.c"
    break;

  case 57: /* serv_option: TIMEOUT NUMBER  */
#line 215 "rcfile_y.y"
                        {current.server.timeout = (yyvsp[0].number);}
#line 2049 "rcfile_y.c"
    break;

  case 58: /* serv_option: IDLETIMEOUT NUMBER  */
#line 217 "rcfile_y.y"
                        {current.server.idle_timeout = (yyvsp[0].number);}
#line 2055 "rcfile_y.c"
    break;

  case 59: /* serv_option: ENVELOPE NUMBER STRING  */
#line 219 "rcfile_y.y"
                                        {
					    current.server.envelope = (yyvsp[0].sval);
					    current.server.envskip = (yyvsp[-1].number);
					}
#line 2064 "rcfile_y.c"
    break;

  case 60: /* serv_option: ENVELOPE STRING  */
#line 224 "rcfile_y.y"
                                        {
					    current.server.envelope = (yyvsp[0].sval);
					    current.server.envskip = 0;
					}
#line 2073 "rcfile_y.c"
    break;

  case 61: /* serv_option: QVIRTUAL STRING  */
#line 229 "rcfile_y.y"
                                        {current.server.qvirtual = (yyvsp[0].sval);}
#line 2079 "rcfile_y.c"
    break;

  case 62: /* serv_option: INTERFACE STRING  */
#line 230 "rcfile_y.y"
                                        {
#ifdef CAN_MONITOR
					interface_parse((yyvsp[0].sval), &current.server);
#else
					fprintf(stderr, GT_("fetchmail: interface option is only supported under Linux (without IPv6) and FreeBSD\n"));
#endif
					free((yyvsp[0].sval));
					}
#line 2092 "rcfile_y.c"
    break;

  case 63: /* serv_option: MONITOR STRING  */
#line 238 "rcfile_y.y"
                                        {
#ifdef CAN_MONITOR
					current.server.monitor = (yyvsp[0].sval);
#else
					fprintf(stderr, GT_("fetchmail: monitor option is only supported under Linux (without IPv6) and FreeBSD\n"));
					free((yyvsp[0].sval));
#endif
					}
#line 2105 "rcfile_y.c"
    break;

  case 64: /* serv_option: PLUGIN STRING  */
#line 246 "rcfile_y.y"
                                        { current.server.plugin = (yyvsp[0].sval); }
#line 2111 "rcfile_y.c"
    break;

  case 65: /* serv_option: PLUGOUT STRING  */
#line 247 "rcfile_y.y"
                                        { current.server.plugout = (yyvsp[0].sval); }
#line 2117 "rcfile_y.c"
    break;

  case 66: /* serv_option: DNS  */
#line 248 "rcfile_y.y"
                                        {current.server.dns = FLAG_TRUE;}
#line 2123 "rcfile_y.c"
    break;

  case 67: /* serv_option: NO DNS  */
#line 249 "rcfile_y.y"
                                        {current.server.dns = FLAG_FALSE;}
#line 2129 "rcfile_y.c"
    break;

  case 68: /* serv_option: NO ENVELOPE  */
#line 250 "rcfile_y.y"
                                        {current.server.envelope = STRING_DISABLED;}
#line 2135 "rcfile_y.c"
    break;

  case 69: /* serv_option: TRACEPOLLS  */
#line 251 "rcfile_y.y"
                                        {current.server.tracepolls = FLAG_TRUE;}
#line 2141 "rcfile_y.c"
    break;

  case 70: /* serv_option: NO TRACEPOLLS  */
#line 252 "rcfile_y.y"
                                        {current.server.tracepolls = FLAG_FALSE;}
#line 2147 "rcfile_y.c"
    break;

  case 71: /* serv_option: BADHEADER ACCEPT  */
#line 253 "rcfile_y.y"
                                        {current.server.badheader = BHACCEPT;}
#line 2153 "rcfile_y.c"
    break;

  case 72: /* serv_option: BADHEADER REJECT_  */
#line 254 "rcfile_y.y"
                                        {current.server.badheader = BHREJECT;}
#line 2159 "rcfile_y.c"
    break;

  case 73: /* serv_option: RETRIEVEERROR ABORT  */
#line 255 "rcfile_y.y"
                                        {current.server.retrieveerror = RE_ABORT;}
#line 2165 "rcfile_y.c"
    break;

  case 74: /* serv_option: RETRIEVEERROR CONTINUE  */
#line 256 "rcfile_y.y"
                                         {current.server.retrieveerror = RE_CONTINUE;}
#line 2171 "rcfile_y.c"
    break;

  case 75: /* serv_option: RETRIEVEERROR MARKSEEN  */
#line 257 "rcfile_y.y"
                                         {current.server.retrieveerror = RE_MARKSEEN;}
#line 2177 "rcfile_y.c"
    break;

  case 76: /* userspecs: user1opts  */
#line 260 "rcfile_y.y"
                                        {record_current(); user_reset();}
#line 2183 "rcfile_y.c"
    break;

  case 78: /* explicits: explicitdef  */
#line 264 "rcfile_y.y"
                                        {record_current(); user_reset();}
#line 2189 "rcfile_y.c"
    break;

  case 79: /* explicits: explicits explicitdef  */
#line 265 "rcfile_y.y"
                                        {record_current(); user_reset();}
#line 2195 "rcfile_y.c"
    break;

  case 81: /* userdef: USERNAME STRING  */
#line 271 "rcfile_y.y"
                                        {current.remotename = (yyvsp[0].sval);}
#line 2201 "rcfile_y.c"
    break;

  case 83: /* userdef: USERNAME STRING THERE  */
#line 273 "rcfile_y.y"
                                        {current.remotename = (yyvsp[-1].sval);}
#line 2207 "rcfile_y.c"
    break;

  case 90: /* mapping: STRING  */
#line 288 "rcfile_y.y"
                                        {if (0 == strcmp((yyvsp[0].sval), "*")) {
					      current.wildcard = TRUE;
					  } else {
					    save_str_pair(&current.localnames, (yyvsp[0].sval), NULL);
					  }
					 free((yyvsp[0].sval));}
#line 2218 "rcfile_y.c"
    break;

  case 91: /* mapping: STRING MAP STRING  */
#line 294 "rcfile_y.y"
                                        {save_str_pair(&current.localnames, (yyvsp[-2].sval), (yyvsp[0].sval)); free((yyvsp[-2].sval)); free((yyvsp[0].sval));}
#line 2224 "rcfile_y.c"
    break;

  case 92: /* folder_list: STRING  */
#line 297 "rcfile_y.y"
                                        {save_str(&current.mailboxes,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 2230 "rcfile_y.c"
    break;

  case 93: /* folder_list: folder_list STRING  */
#line 298 "rcfile_y.y"
                                        {save_str(&current.mailboxes,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 2236 "rcfile_y.c"
    break;

  case 94: /* smtp_list: STRING  */
#line 301 "rcfile_y.y"
                                        {save_str(&current.smtphunt, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2242 "rcfile_y.c"
    break;

  case 95: /* smtp_list: smtp_list STRING  */
#line 302 "rcfile_y.y"
                                        {save_str(&current.smtphunt, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2248 "rcfile_y.c"
    break;

  case 96: /* fetch_list: STRING  */
#line 305 "rcfile_y.y"
                                        {save_str(&current.domainlist, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2254 "rcfile_y.c"
    break;

  case 97: /* fetch_list: fetch_list STRING  */
#line 306 "rcfile_y.y"
                                        {save_str(&current.domainlist, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 2260 "rcfile_y.c"
    break;

  case 98: /* num_list: NUMBER  */
#line 310 "rcfile_y.y"
                        {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[0].number);
			}
#line 2270 "rcfile_y.c"
    break;

  case 99: /* num_list: num_list NUMBER  */
#line 316 "rcfile_y.y"
                        {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[0].number);
			}
#line 2280 "rcfile_y.c"
    break;

  case 104: /* user_option: IS STRING THERE  */
#line 328 "rcfile_y.y"
                                        {current.remotename  = (yyvsp[-1].sval);}
#line 2286 "rcfile_y.c"
    break;

  case 105: /* user_option: PASSWORD STRING  */
#line 329 "rcfile_y.y"
                                        {current.password    = (yyvsp[0].sval);}
#line 2292 "rcfile_y.c"
    break;

  case 106: /* user_option: PASSWORDFILE STRING  */
#line 330 "rcfile_y.y"
                                        {current.passwordfile = (yyvsp[0].sval);}
#line 2298 "rcfile_y.c"
    break;

  case 107: /* user_option: PASSWORDFD NUMBER  */
#line 331 "rcfile_y.y"
                                        {current.passwordfd  = NUM_VALUE_IN((yyvsp[0].number));}
#line 2304 "rcfile_y.c"
    break;

  case 108: /* user_option: PASSWORDEVAL STRING  */
#line 332 "rcfile_y.y"
                                        {current.passwordeval = (yyvsp[0].sval); }
#line 2310 "rcfile_y.c"
    break;

  case 112: /* user_option: SMTPADDRESS STRING  */
#line 336 "rcfile_y.y"
                                        {current.smtpaddress = (yyvsp[0].sval);}
#line 2316 "rcfile_y.c"
    break;

  case 113: /* user_option: SMTPNAME STRING  */
#line 337 "rcfile_y.y"
                                        {current.smtpname =    (yyvsp[0].sval);}
#line 2322 "rcfile_y.c"
    break;

  case 115: /* user_option: MDA STRING  */
#line 339 "rcfile_y.y"
                                        {current.mda         = (yyvsp[0].sval);}
#line 2328 "rcfile_y.c"
    break;

  case 116: /* user_option: BSMTP STRING  */
#line 340 "rcfile_y.y"
                                        {current.bsmtp       = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2334 "rcfile_y.c"
    break;

  case 117: /* user_option: LMTP  */
#line 341 "rcfile_y.y"
                                        {current.listener    = LMTP_MODE;}
#line 2340 "rcfile_y.c"
    break;

  case 118: /* user_option: PRECONNECT STRING  */
#line 342 "rcfile_y.y"
                                        {current.preconnect  = (yyvsp[0].sval);}
#line 2346 "rcfile_y.c"
    break;

  case 119: /* user_option: POSTCONNECT STRING  */
#line 343 "rcfile_y.y"
                                        {current.postconnect = (yyvsp[0].sval);}
#line 2352 "rcfile_y.c"
    break;

  case 120: /* user_option: KEEP  */
#line 345 "rcfile_y.y"
                                        {current.keep        = FLAG_TRUE;}
#line 2358 "rcfile_y.c"
    break;

  case 121: /* user_option: FLUSH  */
#line 346 "rcfile_y.y"
                                        {current.flush       = FLAG_TRUE;}
#line 2364 "rcfile_y.c"
    break;

  case 122: /* user_option: LIMITFLUSH  */
#line 347 "rcfile_y.y"
                                        {current.limitflush  = FLAG_TRUE;}
#line 2370 "rcfile_y.c"
    break;

  case 123: /* user_option: FETCHALL  */
#line 348 "rcfile_y.y"
                                        {current.fetchall    = FLAG_TRUE;}
#line 2376 "rcfile_y.c"
    break;

  case 124: /* user_option: REWRITE  */
#line 349 "rcfile_y.y"
                                        {current.rewrite     = FLAG_TRUE;}
#line 2382 "rcfile_y.c"
    break;

  case 125: /* user_option: FORCECR  */
#line 350 "rcfile_y.y"
                                        {current.forcecr     = FLAG_TRUE;}
#line 2388 "rcfile_y.c"
    break;

  case 126: /* user_option: STRIPCR  */
#line 351 "rcfile_y.y"
                                        {current.stripcr     = FLAG_TRUE;}
#line 2394 "rcfile_y.c"
    break;

  case 127: /* user_option: PASS8BITS  */
#line 352 "rcfile_y.y"
                                        {current.pass8bits   = FLAG_TRUE;}
#line 2400 "rcfile_y.c"
    break;

  case 128: /* user_option: DROPSTATUS  */
#line 353 "rcfile_y.y"
                                        {current.dropstatus  = FLAG_TRUE;}
#line 2406 "rcfile_y.c"
    break;

  case 129: /* user_option: DROPDELIVERED  */
#line 354 "rcfile_y.y"
                                        {current.dropdelivered = FLAG_TRUE;}
#line 2412 "rcfile_y.c"
    break;

  case 130: /* user_option: MIMEDECODE  */
#line 355 "rcfile_y.y"
                                        {current.mimedecode  = FLAG_TRUE;}
#line 2418 "rcfile_y.c"
    break;

  case 131: /* user_option: IDLE  */
#line 356 "rcfile_y.y"
                                        {current.idle        = FLAG_TRUE;}
#line 2424 "rcfile_y.c"
    break;

  case 132: /* user_option: FORCEIDLE  */
#line 357 "rcfile_y.y"
                                        {current.forceidle   = FLAG_TRUE;}
#line 2430 "rcfile_y.c"
    break;

  case 133: /* user_option: SSL_  */
#line 359 "rcfile_y.y"
                                        {
#ifdef SSL_ENABLE
		    current.sslmode = TLSM_WRAPPED;
		    if (outlevel > O_SILENT)
		    yywarn(GT_("WARNING: ssl is obsolescent. Please use sslmode wrapped instead."));
#else
		    yyerror(GT_("SSL is not enabled"));
#endif 
		}
#line 2444 "rcfile_y.c"
    break;

  case 134: /* user_option: SSLKEY STRING  */
#line 368 "rcfile_y.y"
                                        {current.sslkey = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2450 "rcfile_y.c"
    break;

  case 135: /* user_option: SSLCERT STRING  */
#line 369 "rcfile_y.y"
                                        {current.sslcert = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2456 "rcfile_y.c"
    break;

  case 136: /* user_option: SSLMODE STRING  */
#line 370 "rcfile_y.y"
                                        {e_sslmode e = tlsm_parse((yyvsp[0].sval));
					 if (e != TLSM_INVALID) current.sslmode = e;
					 else yyerror(GT_("Invalid sslmode specified."));
					 free((yyvsp[0].sval)); }
#line 2465 "rcfile_y.c"
    break;

  case 137: /* user_option: SSLPROTOVER STRING  */
#line 374 "rcfile_y.y"
                                        {current.sslproto = (yyvsp[0].sval);}
#line 2471 "rcfile_y.c"
    break;

  case 138: /* user_option: SSLCERTCK  */
#line 375 "rcfile_y.y"
                                        {current.sslcertck = FLAG_TRUE;}
#line 2477 "rcfile_y.c"
    break;

  case 139: /* user_option: SSLCERTFILE STRING  */
#line 376 "rcfile_y.y"
                                        {current.sslcertfile = prependdir((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2483 "rcfile_y.c"
    break;

  case 140: /* user_option: SSLCERTPATH STRING  */
#line 377 "rcfile_y.y"
                                        {current.sslcertpath = prependdir((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2489 "rcfile_y.c"
    break;

  case 141: /* user_option: SSLCOMMONNAME STRING  */
#line 378 "rcfile_y.y"
                                        {current.sslcommonname = (yyvsp[0].sval);}
#line 2495 "rcfile_y.c"
    break;

  case 142: /* user_option: SSLFINGERPRINT STRING  */
#line 379 "rcfile_y.y"
                                        {current.sslfingerprint = (yyvsp[0].sval);}
#line 2501 "rcfile_y.c"
    break;

  case 143: /* user_option: NO KEEP  */
#line 381 "rcfile_y.y"
                                        {current.keep        = FLAG_FALSE;}
#line 2507 "rcfile_y.c"
    break;

  case 144: /* user_option: NO FLUSH  */
#line 382 "rcfile_y.y"
                                        {current.flush       = FLAG_FALSE;}
#line 2513 "rcfile_y.c"
    break;

  case 145: /* user_option: NO LIMITFLUSH  */
#line 383 "rcfile_y.y"
                                        {current.limitflush  = FLAG_FALSE;}
#line 2519 "rcfile_y.c"
    break;

  case 146: /* user_option: NO FETCHALL  */
#line 384 "rcfile_y.y"
                                        {current.fetchall    = FLAG_FALSE;}
#line 2525 "rcfile_y.c"
    break;

  case 147: /* user_option: NO REWRITE  */
#line 385 "rcfile_y.y"
                                        {current.rewrite     = FLAG_FALSE;}
#line 2531 "rcfile_y.c"
    break;

  case 148: /* user_option: NO FORCECR  */
#line 386 "rcfile_y.y"
                                        {current.forcecr     = FLAG_FALSE;}
#line 2537 "rcfile_y.c"
    break;

  case 149: /* user_option: NO STRIPCR  */
#line 387 "rcfile_y.y"
                                        {current.stripcr     = FLAG_FALSE;}
#line 2543 "rcfile_y.c"
    break;

  case 150: /* user_option: NO PASS8BITS  */
#line 388 "rcfile_y.y"
                                        {current.pass8bits   = FLAG_FALSE;}
#line 2549 "rcfile_y.c"
    break;

  case 151: /* user_option: NO DROPSTATUS  */
#line 389 "rcfile_y.y"
                                        {current.dropstatus  = FLAG_FALSE;}
#line 2555 "rcfile_y.c"
    break;

  case 152: /* user_option: NO DROPDELIVERED  */
#line 390 "rcfile_y.y"
                                        {current.dropdelivered = FLAG_FALSE;}
#line 2561 "rcfile_y.c"
    break;

  case 153: /* user_option: NO MIMEDECODE  */
#line 391 "rcfile_y.y"
                                        {current.mimedecode  = FLAG_FALSE;}
#line 2567 "rcfile_y.c"
    break;

  case 154: /* user_option: NO IDLE  */
#line 392 "rcfile_y.y"
                                        {current.idle        = FLAG_FALSE;}
#line 2573 "rcfile_y.c"
    break;

  case 155: /* user_option: NO FORCEIDLE  */
#line 393 "rcfile_y.y"
                                        {current.forceidle   = FLAG_FALSE;}
#line 2579 "rcfile_y.c"
    break;

  case 156: /* user_option: NO SSL_  */
#line 395 "rcfile_y.y"
                                        {current.sslmode     = TLSM_NONE;}
#line 2585 "rcfile_y.c"
    break;

  case 157: /* user_option: NO SSLCERTCK  */
#line 396 "rcfile_y.y"
                                        {current.sslcertck   = FLAG_FALSE;}
#line 2591 "rcfile_y.c"
    break;

  case 158: /* user_option: LIMIT NUMBER  */
#line 398 "rcfile_y.y"
                                        {current.limit       = NUM_VALUE_IN((yyvsp[0].number));}
#line 2597 "rcfile_y.c"
    break;

  case 159: /* user_option: WARNINGS NUMBER  */
#line 399 "rcfile_y.y"
                                        {current.warnings    = NUM_VALUE_IN((yyvsp[0].number));}
#line 2603 "rcfile_y.c"
    break;

  case 160: /* user_option: FETCHLIMIT NUMBER  */
#line 400 "rcfile_y.y"
                                        {current.fetchlimit  = NUM_VALUE_IN((yyvsp[0].number));}
#line 2609 "rcfile_y.c"
    break;

  case 161: /* user_option: FETCHSIZELIMIT NUMBER  */
#line 401 "rcfile_y.y"
                                        {current.fetchsizelimit = NUM_VALUE_IN((yyvsp[0].number));}
#line 2615 "rcfile_y.c"
    break;

  case 162: /* user_option: FASTUIDL NUMBER  */
#line 402 "rcfile_y.y"
                                        {current.fastuidl    = NUM_VALUE_IN((yyvsp[0].number));}
#line 2621 "rcfile_y.c"
    break;

  case 163: /* user_option: BATCHLIMIT NUMBER  */
#line 403 "rcfile_y.y"
                                        {current.batchlimit  = NUM_VALUE_IN((yyvsp[0].number));}
#line 2627 "rcfile_y.c"
    break;

  case 164: /* user_option: EXPUNGE NUMBER  */
#line 404 "rcfile_y.y"
                                        {current.expunge     = NUM_VALUE_IN((yyvsp[0].number));}
#line 2633 "rcfile_y.c"
    break;

  case 165: /* user_option: PROPERTIES STRING  */
#line 406 "rcfile_y.y"
                                        {current.properties  = (yyvsp[0].sval);}
#line 2639 "rcfile_y.c"
    break;

  case 166: /* user_option: PWMD_SOCKET STRING  */
#line 408 "rcfile_y.y"
                                        {
#ifdef HAVE_LIBPWMD
		    current.pwmd_socket = xstrdup((yyvsp[0].sval));
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
                }
#line 2651 "rcfile_y.c"
    break;

  case 167: /* user_option: PWMD_SOCKET_ARGS STRING  */
#line 415 "rcfile_y.y"
                                          {
#ifdef HAVE_LIBPWMD
		    current.pwmd_socket_args = xstrdup((yyvsp[0].sval));
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
                }
#line 2663 "rcfile_y.c"
    break;

  case 168: /* user_option: PWMD_FILE STRING  */
#line 422 "rcfile_y.y"
                                        {
#ifdef HAVE_LIBPWMD
		    current.pwmd_file = xstrdup((yyvsp[0].sval));
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
                }
#line 2675 "rcfile_y.c"
    break;


#line 2679 "rcfile_y.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 430 "rcfile_y.y"


static struct query *hosttail;	/* where to add new elements */

/** check that a configuration file is secure, returns PS_* status codes */
int prc_filecheck(const char *pathname,
		  const flag securecheck /** shortcuts permission, filetype and uid tests if false */)
{
    struct stat statbuf;

    errno = 0;

    /* special case useful for debugging purposes */
    if (strcmp("/dev/null", pathname) == 0)
	return(PS_SUCCESS);

    /* pass through the special name for stdin */
    if (strcmp("-", pathname) == 0)
	return(PS_SUCCESS);

    /* the run control file must have the same uid as the REAL uid of this 
       process, it must have permissions no greater than 600, and it must not 
       be a symbolic link.  We check these conditions here. */

    if (stat(pathname, &statbuf) < 0) {
	if (errno == ENOENT) 
	    return(PS_SUCCESS);
	else {
	    report(stderr, "lstat: %s: %s\n", pathname, strerror(errno));
	    return(PS_IOERR);
	}
    }

    if (!securecheck)	return PS_SUCCESS;

    if (!S_ISREG(statbuf.st_mode))
    {
	fprintf(stderr, GT_("File %s must be a regular file.\n"), pathname);
	return(PS_IOERR);
    }

    if (statbuf.st_mode & (S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH | S_IXOTH))
    {
	fprintf(stderr, GT_("File %s must have no more than -rwx------ (0700) permissions.\n"), 
		pathname);
	return(PS_IOERR);
    }

    if (statbuf.st_uid != geteuid())
    {
	fprintf(stderr, GT_("File %s must be owned by you.\n"), pathname);
	return(PS_IOERR);
    }
    return(PS_SUCCESS);
}

int prc_parse_file (const char *pathname, const flag securecheck)
/* digest the configuration into a linked list of host records */
{
    prc_errflag = 0;
    querylist = hosttail = (struct query *)NULL;

    errno = 0;

    /* Check that the file is secure */
    if ( (prc_errflag = prc_filecheck(pathname, securecheck)) != 0 )
	return(prc_errflag);

    /*
     * Croak if the configuration directory does not exist.
     * This probably means an NFS mount failed and we can't
     * see a configuration file that ought to be there.
     * Question: is this a portable check? It's not clear
     * that all implementations of lstat() will return ENOTDIR
     * rather than plain ENOENT in this case...
     */
    if (errno == ENOTDIR)
	return(PS_IOERR);
    else if (errno == ENOENT)
	return(PS_SUCCESS);

    /* Open the configuration file and feed it to the lexer. */
    if (strcmp(pathname, "-") == 0)
	yyin = stdin;
    else if ((yyin = fopen(pathname,"r")) == (FILE *)NULL) {
	report(stderr, "open: %s: %s\n", pathname, strerror(errno));
	return(PS_IOERR);
    }

    yyparse();		/* parse entire file */

    if (yyin != stdin)
       fclose(yyin);	/* not checking this should be safe, file mode was r */

    if (prc_errflag) 
	return(PS_SYNTAX);
    else
	return(PS_SUCCESS);
}

static void reset_server(const char *name, int skip)
/* clear the entire global record and initialize it with a new name */
{
    trailer = FALSE;
    memset(&current,'\0',sizeof(current));
    current.smtp_socket = -1;
    current.passwordfd = -1;
    current.server.pollname = xstrdup(name);
    current.server.skip = skip;
    current.server.principal = (char *)NULL;
}


static void user_reset(void)
/* clear the global current record (user parameters) used by the parser */
{
    struct hostdata save;

    /*
     * Purpose of this code is to initialize the new server block, but
     * preserve whatever server name was previously set.  Also
     * preserve server options unless the command-line explicitly
     * overrides them.
     */
    save = current.server;

    memset(&current, '\0', sizeof(current));
    current.smtp_socket = -1;
    current.passwordfd = -1;

    current.server = save;
}

/** append a host record to the host list */
struct query *hostalloc(struct query *init /** pointer to block containing
					       initial values */)
{
    struct query *node;

    /* allocate new node */
    node = (struct query *) xmalloc(sizeof(struct query));

    /* initialize it */
    if (init)
	memcpy(node, init, sizeof(struct query));
    else
    {
	memset(node, '\0', sizeof(struct query));
	node->smtp_socket = -1;
	node->passwordfd = -1;
    }

    /* append to end of list */
    if (hosttail != (struct query *) 0)
	hosttail->next = node;	/* list contains at least one element */
    else
	querylist = node;	/* list is empty */
    hosttail = node;

    if (trailer)
	node->server.lead_server = leadentry;
    else
    {
	node->server.lead_server = NULL;
	leadentry = &node->server;
    }

    return(node);
}

static void record_current(void)
/* register current parameters and append to the host list */
{
    (void) hostalloc(&current);
    trailer = TRUE;
}

char *prependdir (const char *file, const char *dir)
/* if a filename is relative to dir, convert it to an absolute path */
{
    char *newfile;
    if (!file[0] ||			/* null path */
	file[0] == '/' ||		/* absolute path */
	strcmp(file, "-") == 0 ||	/* stdin/stdout */
	!dir[0])			/* we don't HAVE_GETCWD */
	return xstrdup (file);
    newfile = (char *)xmalloc (strlen (dir) + 1 + strlen (file) + 1);
    if (dir[strlen(dir) - 1] != '/')
	sprintf (newfile, "%s/%s", dir, file);
    else
	sprintf (newfile, "%s%s", dir, file);
    return newfile;
}

/* rcfile_y.y ends here */
